﻿using UnityEngine;
using System.Collections;
using System;

public class tower1script : MonoBehaviour {
	float speed;
	Renderer rend;
	int objno = 0;
	rtcmixmain RTcmix;


	// Use this for initialization
	void Start () {
		speed = 2.0f;

		rend = GetComponent<Renderer> ();

		RTcmix = GameObject.Find ("RTcmixmain").GetComponent<rtcmixmain> ();
		RTcmix.initRTcmix (objno);

		RTcmix.SendScore ("MAXBANG(0.1)", objno);
	}
	
	// Update is called once per frame
	void Update () {
		// up & down
		float heightY = Mathf.Cos(Time.time * speed);
		Vector3 updown = new Vector3 (transform.position.x, heightY, transform.position.z);
		transform.position = updown;

		float red = Mathf.PingPong (Time.time * 1.0f, 1.0f);
		rend.material.color = new Color (red, 0.5F, 1.0f);

		// RTcmix stuff
		RTcmix.setpfieldRTcmix(1, 300.0f + (red*20.0f), objno);
		RTcmix.setpfieldRTcmix (2, heightY / 2.0f + 1.0f, objno);
	}

	void OnAudioFilterRead(float [] data, int nchannels) {
		RTcmix.runRTcmix (data, objno, 0);

		if (RTcmix.checkbangRTcmix (objno) == 1) {
			// FMINST(outsk, dur, AMP, CARFREQ (Hz/oct.pc), MODFREQ (Hz/oct.pc), LOWINDEX, HIGHINDEX[, PAN, WAVETABLE, INDEXENV])
			// GVERB(outsk, insk, dur, AMP, ROOMSIZE, RVBTIME, DAMPING, BANDWIDTH, DRYLEVEL, EARLYREFLECT, RVBTAIL, RINGDOWN[, INCHAN]
			String score = "bus_config(\"FMINST\", \"aux 0-1 out\")  " +
			               "bus_config(\"GVERB\", \"aux 0-1 in\", \"out 0-1\")  " +
			               "GVERB(0, 0, 9999, 0.9, 178.0, 4.0, 0.5, 0.34, -1.0, -11.0, -9.0, 7.0)  " +
			               "wave = maketable(\"wave\", 1000, \"sine\")  " +
			               "modfreq1 = makeconnection(\"inlet\", 1, 300)  " +
			               "index1 = makeconnection(\"inlet\", 2, 0)  " +
			               "FMINST(0, 9999, 5000*index1, 300, modfreq1, 0, 10, 0.5, wave, index1)";
			RTcmix.SendScore (score, objno);
		}
	}
}
